<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->
<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="categories-list.html">

<link rel="import" href="../bower_components/app-layout/app-header/app-header.html">
<link rel="import" href="../bower_components/app-layout/app-header-layout/app-header-layout.html">
<link rel="import" href="../bower_components/app-layout/app-scroll-effects/effects/waterfall.html">
<link rel="import" href="../bower_components/app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">

<link rel="import" href="../bower_components/app-route/app-location.html">
<link rel="import" href="../bower_components/app-route/app-route.html">
<link rel="import" href="../bower_components/app-layout/helpers/helpers.html">
<link rel="import" href="../bower_components/iron-media-query/iron-media-query.html">
<link rel="import" href="../bower_components/iron-meta/iron-meta.html">

<link rel="import" href="../bower_components/iron-pages/iron-pages.html">
<link rel="import" href="../bower_components/iron-selector/iron-selector.html">
<link rel="import" href="collection-observer.html">

<link rel="import" href="food-image.html">
<link rel="import" href="food-cart-data.html">

<!-- <link rel="import" href="shop-payment-request.html"> -->

<!-- <link rel="import" href="shop-googleyolo.html"> -->
<!-- Since 'home' is the default route, eagerly load it. -->
<link rel="import" href="food-home.html">
<link rel="import" href="food-order-success-modal.html">

<dom-module id="food-app">

  <template>
    <style is="custom-style" include="iron-flex iron-flex-alignment iron-positioning"></style>
      
    <style>

      :host {
        display: block;
        position: relative;
        padding-top: 128px;
        padding-bottom: 64px;
        min-height: 100vh;
        --app-primary-color: #202020;
        --app-secondary-color: #757575;
        --app-accent-color: #172C50;
        --paper-button-ink-color: var(--app-accent-color);
        --paper-icon-button-ink-color: var(--app-accent-color);
        --paper-spinner-color: var(--app-accent-color);
        -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
        color: var(--app-primary-color);
      }

      #header {
        height: 112px;
      }

      app-header {
        @apply --layout-fixed-top;
        z-index: 1;
        background-color: rgba(255, 255, 255, 0.95);
        --app-header-shadow: {
          box-shadow: inset 0px 5px 6px -3px rgba(0, 0, 0, 0.2);
          height: 10px;
          bottom: -10px;
        };
      }
   

      paper-icon-button {
        color: var(--app-primary-color);
      }

      .logo {
        text-align: center;
      }

      .logo a {
        font-size: 16px;
        font-weight: 400;
        font-family: 'Roboto', 'Noto', sans-serif;
        letter-spacing: 0.3em;
        color: var(--app-primary-color);
        text-decoration: none;
        /* required for IE 11, so this <a> can receive pointer events */
        display: inline-block;
        pointer-events: auto;
      }

      .left-bar-item {
        width: 140px;
      }

      .menu-btn {
        display: none;
      }

      .cart-btn-container {
        position: relative;
        width: 40px;
      }

      .announcer {
        position: fixed;
        height: 0;
        overflow: hidden;
      }

      [hidden] {
        display: none !important;
      }

      #tabContainer {
        position: relative;
        height: 66px;
      }

      shop-tabs, shop-tab {
        --shop-tab-overlay: {
          border-bottom: 2px solid var(--app-accent-color);
        };
      }

      shop-tabs {
        height: 100%;
      }

      shop-tab {
        margin: 0 10px;
      }

      shop-tab a {
        display: inline-block;
        outline: none;
        padding: 9px 5px;
        font-size: 13px;
        font-weight: 500;
        text-decoration: none;
        color: var(--app-primary-color);
      }

      .cart-badge {
        position: absolute;
        top: -2px;
        right: 0;
        width: 20px;
        height: 20px;
        background-color: var(--app-accent-color);
        border-radius: 50%;
        color: white;
        font-size: 12px;
        font-weight: 500;
        pointer-events: none;
        @apply --layout-vertical;
        @apply --layout-center-center;
      }

      .drawer-list {
        margin: 24px 20px;
      }

      .drawer-list a {
        display: block;
        padding: 0 16px;
        line-height: 40px;
        text-decoration: none;
        color: var(--app-secondary-color);
      }

      .drawer-list a.iron-selected {
        color: black;
        font-weight: bold;
      }

      food-cart-modal {
        z-index: 2;
      }

      app-drawer {
        z-index: 3;
      }

      iron-pages {
        width: 100%;
        max-width: 1440px;
        margin: 0 auto;
        margin-top: 64px;
      }

      footer {
        position: absolute;
        bottom: 0;
        left: 0;
        right: 0;
        text-align: center;
        margin-top: 20px;
        line-height: 24px;
      }

      footer > a {
        color: var(--app-secondary-color);
        text-decoration: none;
      }

      footer > a:hover {
        text-decoration: underline;
      }

      .demo-label {
        box-sizing: border-box;
        width: 120px;
        padding: 6px;
        margin: 8px auto 0;
        background-color: var(--app-primary-color);
        color: white;
        text-transform: uppercase;
      }

      .account-btn-container paper-icon-button {
        clip-path: circle(11px at center);
      }

      #title
      {
        font-size: 1.4em;
        font-weight: 400;
      }

      /* small screen */
      @media (max-width: 767px) {
        :host {
          /* padding-top: 164px; */
        }

        #header {
          height: 112px;
        }

        .menu-btn {
          display: block;
        }

        :host([page=detail]) .menu-btn {
          display: none;
        }

        #title
        {
          font-size: 1em;
          font-weight: 300;
        }

        iron-pages {
          max-width: 767px;
          margin: 0;
        }


      }

      #account
      {
        margin: 100% auto;
      }

      .about
      {
        outline: none;
        text-decoration: none;
      }
    
      .about h3
      {
  
        font-size: 0.88em;
        font-weight: 300;
        padding: 0 24px;
      }

      :host([page="about"])
      {
        padding-top: 64px;
      }

      h1[name=opened]
      {
        font-size: 1.4em;
        font-weight: 300;
        width: 100%;
        text-align: center;
      }
      h1[name="delivery"]
      {
        font-size: 0.9em;
        font-weight: 300;
        width: 100%;
        text-align: center; 
      }
      h2[name="delivery"]
      {
        margin: 0;
        font-size: 0.8em;
        font-weight: 300;
        width: 100%;
        text-align: center; 
      }

      #tabContainer
      {
        background: rgba(255, 255, 255, 0.9)
      }

      food-image[name="logo"]
      {
        width: 56px;
        height: 56px;
      }

    </style>

    <shop-analytics key="UA-109241460-1"></shop-analytics>
    <!--
      app-location and app-route elements provide the state of the URL for the app.
    -->
    <app-location route="{{route}}"></app-location>
    <app-route
        route="{{route}}"
        pattern="/:page"
        data="{{routeData}}"
        tail="{{subroute}}"></app-route>
        
    <iron-media-query query="max-width: 767px" query-matches="{{smallScreen}}"></iron-media-query>
    <iron-meta id="meta" type="account"></iron-meta>
    <!--
      food-cart-data maintains the state of the user's shopping cart (in localstorage) and
      calculates the total amount.
    -->
    <collection-observer name="orders" subscribed=[[subscribed]]></collection-observer>

    <food-cart-data
        id="cart"
        cart="{{cart}}"
        num-items="{{numItems}}"
        total="{{total}}"></food-cart-data>

           <!--
      shop-googleyolo maintains the state of the user's account (in
      localstorage). Does not, and should not, store password.
    -->
  <!-- <shop-googleyolo
    id="account"
    profile="{{profile}}"></shop-googleyolo> -->

<!--
  shop-payment-request provides the logic and hooks into the PaymentRequest API.
-->

<!-- supported-methods='["https://emerald-eon.appspot.com/alicepay","https://emerald-eon.appspot.com/bobpay"]'
      pay-with-google='{"merchantId":"02510116604241796260","environment":"TEST","apiVersion":1,"allowedPaymentMethods":["CARD","TOKENIZED_CARD"],"paymentMethodTokenizationParameters": { "tokenizationType":"PAYMENT_GATEWAY", "parameters": {"gateway":"stripe","stripe:publishableKey":"pk_test_fkdoiK6FR5BLZMFNbSGoDjpn","stripe:version":"5.1.0"}},"cardRequirements":{ "allowedCardNetworks":["AMEX","DISCOVER","MASTERCARD","VISA"], "billingAddressRequired":true,"billingAddressFormat":"FULL"}, "phoneNumberRequired":false,"emailRequired":false, "shippingAddressRequired":false}' -->
      <!-- shipping-type="shipping" -->
<!-- <shop-payment-request
    id="paymentRequest"
    page="[[page]]"
    cart="[[cart]]"
    total="[[total]]"
    currency="RUB"
    basic-card='["visa", "mastercard","maestro","mir"]'
    request-payer-phone
    request-payer-name>
</shop-payment-request> -->
<app-header-layout fullbleed>
    <app-header slot="header" role="navigation" id="header" fixed effects="waterfall">
      <app-toolbar>
        <div class="left-bar-item">
          <paper-icon-button hidden$=[[hiddenNotHome(page)]]
              class="menu-btn"
              icon="menu"
              on-click="_toggleDrawer"
              aria-label="Categories">
          </paper-icon-button>

          <a class="back-btn" href="/list/[[categoryName]]" tabindex="-1" hidden$=[[hiddenNotDetail(page)]]>
            <paper-icon-button icon="arrow-back" aria-label="Go back"></paper-icon-button>
          </a>
          <a class="back-home-btn" tabindex="-1" on-tap="_redirectToHome">
            <paper-icon-button icon="arrow-back" aria-label="Go back" hidden$=[[hiddenHomeOrDetail(page)]]></paper-icon-button>
          </a>
        </div>
        <div class="logo" main-title><a aria-label="[[title]]" on-tap="_redirectToHome"><h1 id="title">[[title]]</h1></a></div>
        <a class="about" href="/about" tabindex="-1" hidden$=[[smallScreen]]>
          <h3>О нас</h3>
        </a>
        <div class="cart-btn-container" hidden$=[[_favorites(page,loggedIn)]]>
   
              <paper-icon-button
                icon="[[_accountIcon(loggedIn)]]"
                aria-label="Account"
                on-click="_onLogin"></paper-icon-button>
    
            <div class="cart-badge" aria-hidden="true" hidden$=[[!newOrder]]>1</div>                    
        </div>
        <div class="cart-btn-container" hidden$=[[!_favorites(page,loggedIn)]]>    
            <paper-icon-button
              icon="[[_favoritesIcon(product.favorite)]]"
              aria-label="Account"
              on-tap="_toggleFavorites"></paper-icon-button>
      </div>
        <div class="cart-btn-container">          
          <paper-icon-button icon="shopping-cart" on-tap="_redirectToCheckout"
            aria-label$="Shopping cart: [[_computePluralizedQuantity(numItems)]]"></paper-icon-button>          
          <div class="cart-badge" aria-hidden="true" hidden$="[[!numItems]]">[[numItems]]</div>
        </div>
      </app-toolbar>
    <app-toolbar style="height: 48px" hidden$=[[!deliveryShow]]>
             
        <!-- <div hidden$=[[deliveryToday]]> -->
        <div style="width:100%">
            <h2 name="delivery">Принимаем заказы на утро вечером до [[deliveryTime]]</h2>
        </div>
        <!-- <h1 name="opened" hidden$=[[!deliveryToday]]>C 01.01 по 04.01 доставки нет. Заказы на 5 января!</h1> -->
    </app-toolbar>
      <!-- Lazy-create the tabs for larger screen sizes. -->
      <div id="tabContainer" sticky$="[[_shouldShowTabs]]" hidden$="[[!_shouldShowTabs]]">
  
        <dom-if if="[[_shouldRenderTabs]]">
          <template>
            <shop-tabs
                selected="[[categoryName]]"
                attr-for-selected="name">

              <shop-tab style="position: absolute; margin-left: -64px; margin-top: -16px">
                  <food-image name="logo" alt="zavtrak.online!" src="backgrounds/icon-512"></food-image>
              </shop-tab>

              <dom-repeat items="[[categories]]" as="category" initial-count="4">
                <template>                
                  <shop-tab name="[[category.name]]">
                    <a href="/list/[[category.name]]">[[category.title]]</a>
                  </shop-tab>
                </template>
              </dom-repeat>
            </shop-tabs>
          </template>
        </dom-if>
      </div>
    </app-header>

    <!-- Lazy-create the drawer for small screen sizes. -->
    <dom-if if="[[_shouldRenderDrawer]]">
      <template>
      <!-- Two-way bind `drawerOpened` since app-drawer can update `opened` itself. -->
      <app-drawer opened="{{drawerOpened}}" swipe-open tabindex="0">
        <div class="layout vertical" style="margin-top: 96px">
          <iron-selector role="navigation" class="drawer-list" selected="[[categoryName]]" attr-for-selected="name">
            <a class="about" name="about" href="/about" style="border-bottom: 1px solid lightgray">
                О нас
            </a>
            <dom-repeat items="[[categories]]" as="category" initial-count="4">
              <template>
                <a name="[[category.name]]" href="/list/[[category.name]]">[[category.title]]</a>
              </template>
            </dom-repeat>
           
          </iron-selector>
          <!-- <div id="account">
            <dom-if if="[[user]]">
              <template>
                <h2>[[user.profile.name]]</h2>
                <paper-button>
                    Мои заказы
                </paper-button>
                <paper-button on-tap="_logout">
                    Разлогиниться
                </paper-button>
              </template>
            </dom-if>
          </div> -->
        </div>
      </app-drawer>
      </template>
    </dom-if>

    <iron-pages role="main" selected="[[page]]" attr-for-selected="name" selected-attribute="visible" fallback-selection="404">
      <!-- home view -->
      <food-home name="home" categories="[[categories]]" wide=[[!smallScreen]]></food-home>
      <!-- list view of items in a category -->
      <food-list id="list" name="list" route="[[subroute]]" offline="[[offline]]" wide=[[!smallScreen]]></food-list>
      <!-- detail view of one item -->
      <food-detail id="detail" name="detail" route="[[subroute]]" offline="[[offline]]" phone=[[smallScreen]]></food-detail>
      <!-- cart view -->

      <!-- checkout view -->
      <food-checkout id="checkout" name="checkout" cart="[[cart]]" total="[[total]]" route="{{subroute}}" num-items="{{numItems}}"></food-checkout>
      
      <food-account name="account" profile="[[profile]]" route="[[subroute]]" prefilled-email="[[userEmail]]" reset-token=[[resetToken]]></food-account>
      <div name="reset">
        <form id="resetForm" is="iron-form">           
            <div class="row input-row">
            <food-input>
              <input type="password" id="newPassword" name="password"
                  placeholder="Новый пароль" required
                  aria-labelledby="accountPasswordLabel"
                  autocomplete="current-password"
                  autofocus$="true">
              <food-md-decorator  error-message="Неправильный пароль" aria-hidden="true">
                <label id="accountPasswordLabel">Пароль</label>
                <shop-underline></shop-underline>
              </food-md-decorator >
            </food-input>
          </div>
        </form>
        <food-button responsive id="password">
          <input type="button" on-click="_onPasswordReset" value="Установить">
        </food-button>
      </div>
      <food-404-warning name="404"></food-404-warning>

      <food-dev id="dev" name="dev"></food-dev>

      <food-kitchen name="kitchen"></food-kitchen>
      
      <food-kitchen name="delivery" delivery></food-kitchen>

      <food-orders name="orders"></food-orders>
      <food-staff name="staff"></food-staff>
      
      <food-enter name="enter"></food-enter>
      <food-order name="order" order="[[order]]"></food-order>
      
      <food-about name="about" phone=[[smallScreen]] delivery-time=[[deliveryTime]]></food-about>

      <food-profile name="profile"></food-profile>
      
      <food-payment name="payment"></food-payment>
      <food-test name="test"></food-test>

    </iron-pages>


    <!-- a11y announcer -->
    <div class="announcer" aria-live="assertive">[[_a11yLabel]]</div>
</app-header-layout>
  </template>

  <script>
    
    Polymer.setPassiveTouchGestures(true);
    // performance logging
    window.performance && performance.mark && performance.mark('food-app - before register');

    class FoodApp extends CategoriesList {

      static get is() { return 'food-app'; }

      static get properties() { return {
        title:{
          type: String,
          value: "Завтрак.online"
        },
        deliveryTime:{
          type: String,
          value: '23-00'
        },
        version:{
          type: String,
          value: "1.0.1"
        },
        user: {
          type: Function,
          value: Meteor.user()
        },
        
        page: {
          type: String,
          reflectToAttribute: true,
          observer: '_pageChanged'
        },
        loggedIn: Boolean,

        userEmail: {
          type: String,
          value: ''
        },

        numItems: {
          type: Number,
          value: 0
        },
        deliveryNextDay:{
           type: Number,
           value: 10 //10am                   
        },
        deliveryShow: {
          type: Boolean,
          value: true
        },
        deliveryToday:{
          type: Boolean,
          value: true
        },
        _shouldShowTabs: {
          computed: '_computeShouldShowTabs(page, smallScreen)'
        },

        _shouldRenderTabs: {
          computed: '_computeShouldRenderTabs(_shouldShowTabs, loadComplete)'
        },

        _shouldRenderDrawer: {
          computed: '_computeShouldRenderDrawer(smallScreen, loadComplete)'
        },
        subroute:Object,
        order: Object,
        newOrder: {
          type: Boolean,
          value: false
        }

      }}

      static get observers() { return [
        '_routePageChanged(routeData.page)',
        '_subrouteChanged(subroute.prefix, subroute.__queryParams)'
      ]}

      constructor() {
        super();
        window.performance && performance.mark && performance.mark('food-app.created');
      }
      _subrouteChanged(prefix,query)
      {      
        if( prefix == '/order' )
        {
          Tracker.autorun(() => {
                Meteor.subscribe('order', query._id,()=>this.order = Orders.findOne(query));
                this.subscribed = true;
            });
        }
        
        if( prefix == '/qr' )
        {
          this.loginWithToken(query['token']);          
        }
      }
      
      _onPasswordReset()
      {
        // console.log("1");

        Accounts.resetPassword(this.resetToken, this.$.newPassword.value, (err, result)=>{  
          this._showSnackbar( err ? err.reason : 'Новый пароль установлен');
        })
      }

      hiddenNotHome(page)
      {
        return page != 'home'
      }
      hiddenNotDetail(page)
      {
        return page != 'detail'
      }
      hiddenHomeOrDetail(phone)
      {
        return phone === 'home' || phone === 'detail'
      }

      _accountIcon(loggedIn)
      {
        return loggedIn ? 'face': 'account-circle';
      }

      _favorites(page,loggedIn)
      {
        return  page === 'detail' && loggedIn;
      }
      _favoritesIcon(favorite)
      {
        return favorite ? 'icons:star': 'icons:star-border'
      }

      _toggleFavorites()
      {
        if( this.product )
        {
          if( !this.product.favorite )
          {
            Meteor.call('addToFavorites', this.product._id);
            this.set('product.favorite', true); 
          }else
          {
            Meteor.call('removeFromFavorites', this.product._id);
            this.set('product.favorite', false);
          } 
        }
      }

      loginWithToken(token, params, argName = 'authToken') {
          if (!token || Meteor.userId()) {
            return;
          }
          var self = this;  
          var methodArgument = {};

          methodArgument[`dispatch_${argName}`] = token;
       
            Accounts.callLoginMethod({
              methodArguments: [methodArgument],
              userCallback: function (err) {
                if (err) {
                  
                  self._announce('Login failed');
                } else {
               
                  self.dispatchEvent(new CustomEvent('route-change', {
                    bubbles: true, composed: true, detail: {
                      path: '/home'
                    }}));                  
                }
              },
            });
    
        }


      connectedCallback() {
            super.connectedCallback();

            firebase.messaging().onMessage((payload)=>{
                console.log("onMessage", payload)
                // new Notification(payload.notification.title, payload.notification);
                Notification.requestPermission(function(result) {
                  if (result === 'granted') {
                      navigator.serviceWorker.ready.then(function(registration) {
                          // теперь мы можем показать уведомление
                          return registration.showNotification(payload.notification.title, payload.notification);
                      }).catch(function(error) {
                          console.log('ServiceWorker registration failed', error);
                      });
                  }
              });
            })

            Polymer.RenderStatus.afterNextRender(this,()=>{
              Tracker.autorun(() => {
                this.loggedIn = !!Meteor.user();
                if( this.loggedIn )
                {
                  ga('set', 'userId', Meteor.userId()); // Set the user ID using signed-in user_id.
                }
          
                Meteor.subscribe('products');
              });
            });
        }

      _autoLogin() {
        var that = this;
        this.accountData = this.$.meta.byKey('account');

        // If already signed in, no need to auto sign-in.
        if (this.accountData.isSignedIn()) return;

        this.accountData.autoSignIn()
        .then(function(profile) {
          if (profile) {
            that.fire('show-snackbar', {
              text: 'You are signed in!'
            });
          } else {
            console.log('No credentials found');
          }
        }, function(err) {
          console.log('auto sign-in did not happen');
        });
      }

      _onLogin(event) {
        this.set('route.path', '/account');
      }
      
      _onLogout(event) {
        this.accountData.logout();
        this.fire('show-snackbar', {
          text: 'You are signed out.'
        });
      }

      ready() {
        window.app = this;
   
        this.userEmail = '';

        super.ready();
        this.payment = this.$.paymentRequest;
        // Custom elements polyfill safe way to indicate an element has been upgraded.
        this.removeAttribute('unresolved');
        // listen for custom events
        this.addEventListener('add-cart-item', (e)=>this._onAddCartItem(e));
        this.addEventListener('set-cart-item', (e)=>this._onSetCartItem(e));
        this.addEventListener('clear-cart', (e)=>this._onClearCart(e));
        this.addEventListener('buy-cart', (e)=>this._onBuyCart(e));
        
        
        this.addEventListener('order-placed', (e)=>{
          this.newOrder = true;
          setTimeout(() => this.newOrder = false, 35000);
          this._onClearCart(e)
        });

        // this.addEventListener('offer-create-account', (e)=>{
     
 
        // });


        this.addEventListener('route-change', (e)=> {         
            this.set('route.path', e.detail.path)
          });
      
        this.addEventListener('change-section', (e)=>this._onChangeSection(e));
        this.addEventListener('announce', (e)=>this._onAnnounce(e));
        this.addEventListener('dom-change', (e)=>this._domChange(e));
        this.addEventListener('show-invalid-url-warning', (e)=>this._onFallbackSelectionTriggered(e));
        
        
        // listen for online/offline
        Polymer.RenderStatus.afterNextRender(this, () => {
          window.addEventListener('online', (e)=>this._notifyNetworkStatus(e));
          window.addEventListener('offline', (e)=>this._notifyNetworkStatus(e));
          window.addEventListener('account-ready', (e)=>this._autoLogin(e));
        });

        this.updateDeliveryToday();
        setInterval(()=>this.updateDeliveryToday,1000*60*30)

      }
      updateDeliveryToday()
      {
        var d = new Date();
            d.setHours(this.deliveryNextDay);
            if( Date.now() > d )
            {
              this.deliveryToday = false;
            }
      }

      _onBuyCart(event) {
        if ('PaymentRequest' in window) {
          var that = this;
          var itemDetails = this.payment._computeItemDetails();
          this.currentOrderId = event.detail.orderId;              
          var total = itemDetails.reduce(function(sum,item){
            return sum + parseFloat(item.amount.value);
          }, 0);
          this.payment.buyItems(itemDetails, total)
          .then(function(instrument) {
            return that._processPayment(instrument, true);
          }).catch(function(err) {
            if (err === 'Request cancelled') {
              // Do nothing
            } else if (err.name === 'NotSupportedError') {
              that._redirectToCheckout();
            } else {
              console.error('Error while handling PaymentRequest.show(): ' + err);
            }
          });
        } else {
          this._redirectToCheckout();
          return;
        }
      }
      _redirectToHome()
      {
          console.log("#_redirectToHome")   
          this.set('route.path', '/');
      }

      _redirectToCheckout() {
        // prevent reload loop if we're already on /checkout.
//         console.log("#_redirectToCheckout")
        if (this.route.path !== '/checkout') {
          this.set('route.path', '/checkout');

          
          return;
        }else
        {
          this.$.checkout.state = 'init';
        }
      }

      _orderSuccessModal(order)
      {
        if (!this.orderSuccessModal) {
            this.orderSuccessModal = document.createElement('food-order-success-modal');           
            Polymer.dom(this.root).appendChild(this.orderSuccessModal);
        }
        this.orderSuccessModal.order = order;
        this.orderSuccessModal.open();
        this._announce('Order processed successfully!');
      }

      _processPayment(instrumentResponse, cartBuy) {
        // This is normally where you'd send instrumentResponse to your backend
        // or payment processor. For this demo we don't actually do that,
        // instead mimicking a processing delay with a 2-second timout.
        //
        // See the PaymentRequest integration guide for a typical flow:
        // https://developers.google.com/web/fundamentals/primers/payment-request/
     
// console.log("#processPayment",this.currentOrderId,instrumentResponse,cartBuy);
        
        Meteor.call("processPayment",this.currentOrderId,instrumentResponse, cartBuy);

        window.setTimeout(function() {
          
          
          var that = this;
          instrumentResponse.complete('success')
            .then(function() {
              // Proceed to sign-in if the user is not signed up            
              if (!that.accountData.isSignedIn()) {
                that.userEmail = instrumentResponse.payerEmail;
                that.set('route.path', '/account/signup');
              } else {
                that._orderSuccessModal();
              }
              if (cartBuy) {
                //wont work
                // that.fire('clear-cart');
              }
            });
        }, 5000);
      }

      _routePageChanged(page) {
        
        ga('set', 'page', '/'+ page);
        // ga('send', 'pageview', [page], [fieldsObject]);
        ga('send', 'pageview');
        
        if (page === 'reset')
        {            
            this.resetToken = this.subroute.path.slice(1);
        }else
        {
          this.resetToken = '';
        }
        // ga('send', 'event', 'route', 'page', page ,this.route);
        if (page === 'home') {
          this.page = page;
          return
        }
        
        if (this.page === 'list') {
          this._listScrollTop = window.pageYOffset;
        }
        
        if(page === 'account' && Meteor.user())
        {
          page = 'profile'
          this.newOrder = false; 
        }else
        if( this.route.path === '/checkout/success' ) 
        {      
          Polymer.RenderStatus.afterNextRender(this,()=>{
            this.$.checkout.state = 'success';
            this._onClearCart();
          });
          
        }else
        if(this.page === 'checkout' && page)
        {    
          Polymer.RenderStatus.afterNextRender(this,()=>{
            this.newOrder = false;   
            this.$.checkout.state = 'init';
          });                                    
          return;  
        }else
        if( page === 'account' && this.page === 'account' ){
          Polymer.RenderStatus.afterNextRender(this,()=>{
            this.$.checkout.state = page;
          });
          return;  
        }
                               
        this.page = page || 'home';

        // Close the drawer - in case the *route* change came from a link in the drawer.
        this.drawerOpened = false;
      }

      _pageChanged(page, oldPage) {
        if (page != null) {
          // home route is eagerly loaded
          if (page == 'delivery')
          {
            page = 'kitchen'
          }

          ga('send', 'event', {
            'eventCategory': 'page',
            'eventAction': 'route',
            'eventLabel': page
          });

          if (page == 'home') {
            this._pageLoaded(Boolean(oldPage));
          // other routes are lazy loaded
          } else {
            // When a load failed, it triggered a 404 which means we need to
            // eagerly load the 404 page definition
            let cb = this._pageLoaded.bind(this, Boolean(oldPage));
            let path = (page == 'dev')?'food-dev.html':'food-' + page + '.html'
            
            Polymer.importHref(
              this.resolveUrl(path),
              cb, cb, true);
          }
        }
      }

      _pageLoaded(shouldResetLayout) {
        this._ensureLazyLoaded();
        if (shouldResetLayout) {
          // The size of the header depends on the page (e.g. on some pages the tabs
          // do not appear), so reset the header's layout only when switching pages.
          Polymer.Async.timeOut.run(() => {
            this.$.header.resetLayout();
          }, 1);
        }
      
      }

      _ensureLazyLoaded() {
        // load lazy resources after render and set `loadComplete` when done.
        if (!this.loadComplete) {
          Polymer.RenderStatus.afterNextRender(this, () => {
            Polymer.importHref(this.resolveUrl('lazy-resources.html'), () => {
              // Register service worker if supported.
              // if ('serviceWorker' in navigator) {
              //   navigator.serviceWorker.register('service-worker.js', {scope: '/'});
              // }
              this._notifyNetworkStatus();
              this.loadComplete = true;
            });
          });
        }
      }
      
      _showSnackbar(text) {

        if (!this._networkSnackbar) {
          this._networkSnackbar = document.createElement('shop-snackbar');
          Polymer.dom(this.root).appendChild(this._networkSnackbar);
        }
        Polymer.dom(this._networkSnackbar).innerHTML = text;
        this._networkSnackbar.open();
      }

      _notifyNetworkStatus() {
        let oldOffline = this.offline;
        this.offline =  !navigator.onLine;
        // Show the snackbar if the user is offline when starting a new session
        // or if the network status changed.
        if (this.offline || (!this.offline && oldOffline === true)) {
          if (!this._networkSnackbar) {
            this._networkSnackbar = document.createElement('shop-snackbar');
            this.root.appendChild(this._networkSnackbar);
          }
          this._networkSnackbar.innerHTML = this.offline ?
              'You are offline' : 'You are online';
          this._networkSnackbar.open();
        }
      }

      _toggleDrawer() {
        this.drawerOpened = !this.drawerOpened;
      }

      // Elements in the app can notify section changes.
      // Response by a11y announcing the section and syncronizing the category.
      _onChangeSection(event) {
        let detail = event.detail;

        // Scroll to the top of the page when navigating to a non-list page. For list view,
        // scroll to the last saved position only if the category has not changed.
        let scrollTop = 0;
        if (this.page === 'list') {
          if (this.categoryName === detail.category) {
            scrollTop = this._listScrollTop;
          } else {
            // Reset the list view scrollTop if the category changed.
            this._listScrollTop = 0;
          }
          ga('send', 'event', {
            'eventCategory': 'list',
            'eventAction': 'Переход в категорию',
            'eventLabel': detail.title
          });
        }
        if (this.page === 'detail' && detail.item) {
          
          ga('send', 'event', {
            'eventCategory': 'detail',
            'eventAction': 'Просмотр продукта',
            'eventLabel': JSON.stringify(_.pick(detail.item,'_id','title'))
          });
          this.product = detail.item;
          this.set('product.favorite', !!Favorites.find({productId: this.product._id}).count());
        }

        // Use `Polymer.AppLayout.scroll` with `behavior: 'silent'` to disable header scroll
        // effects during the scroll.
        Polymer.AppLayout.scroll({ top: scrollTop, behavior: 'silent' });

        this.categoryName = detail.category || '';

        // Announce the page's title
        if (detail.title) {
          document.title = detail.title + ' - FOOD';
          this._announce(detail.title + ', loaded');
        }
      }

      _onAddCartItem(event) {
        if (!this._cartModal) {
          this._cartModal = document.createElement('food-cart-modal');
          this.root.appendChild(this._cartModal);
        }
        if(event)
        {    
          ga('send', 'event', {
            'eventCategory': 'addToCart',
            'eventAction': 'Добавлено в корзину',
            'eventLabel': JSON.stringify(_.extend(_.pick(event.detail.item,"name","_id"),event.detail.quantity))
          });

          this.$.cart.addItem(event.detail);
        }
       
        this._cartModal.open();
        this._announce('Item added to the cart');
      }

      _onSetCartItem(event) {
        let detail = event.detail;
        this.$.cart.setItem(detail);
        if (detail.quantity === 0) {
          this._announce('Item deleted');
        } else {
          this._announce('Quantity changed to ' + detail.quantity);
        }
      }

      _onClearCart() {
        this.$.cart.clearCart();
        this._announce('Cart cleared');
      }

      // Elements in the app can notify a change to be a11y announced.
      _onAnnounce(e) {
        this._announce(e.detail);
      }

      // A11y announce the given message.
      _announce(message) {
        this._a11yLabel = '';
        this._announceDebouncer = Polymer.Debouncer.debounce(this._announceDebouncer,
          Polymer.Async.timeOut.after(100), () => {
            this._a11yLabel = message;
          });
      }

      // This is for performance logging only.
      _domChange(e) {
        if (window.performance && performance.mark && !this.__loggedDomChange) {
          let target = e.composedPath()[0];
          let host = target.getRootNode().host;
          if (host && host.localName.match(this.page)) {
            this.__loggedDomChange = true;
            performance.mark(host.localName + '.domChange');
          }
        }
      }

      _enter()
      {
        console.log("enter")
        this.page = 'enter';
        this._toggleDrawer()

      }
      _logout()
      {
        Meteor.logout();
      }

      _onFallbackSelectionTriggered() {
        this.page = '404';
      }

      _computeShouldShowTabs(page, smallScreen) {
        return (page === 'home' || page === 'list' || page === 'detail') && !smallScreen;
      }

      _computeShouldRenderTabs(_shouldShowTabs, loadComplete) {
        return _shouldShowTabs && loadComplete;
      }

      _computeShouldRenderDrawer(smallScreen, loadComplete) {
        return smallScreen && loadComplete;
      }

      _computePluralizedQuantity(quantity) {
        return quantity + ' ' + (quantity === 1 ? 'item' : 'items');
      } 
      
      _computeProfileIcon(profile) {
        if (profile && profile.id) {
          return profile.iconURL ? '' : 'face';
        } else {
          return 'account-circle';
        }
      }

    }

    customElements.define(FoodApp.is, FoodApp);

  </script>

</dom-module>
